---
minutes: 2
---

# Playground

The [Rust Playground](https://play.rust-lang.org/) provides an easy way to run
short Rust programs, and is the basis for the examples and exercises in this
course. Try running the "hello-world" program it starts with. It comes with a
few handy features:

- Under "Tools", use the `rustfmt` option to format your code in the "standard"
  way.

- Rust has two main "profiles" for generating code: Debug (extra runtime checks,
  less optimization) and Release (fewer runtime checks, lots of optimization).
  These are accessible under "Debug" at the top.

- If you're interested, use "ASM" under "..." to see the generated assembly
  code.

<details>

As students head into the break, encourage them to open up the playground and
experiment a little. Encourage them to keep the tab open and try things out
during the rest of the course. This is particularly helpful for advanced
students who want to know more about Rust's optimizations or generated assembly.

</details>
